Package net.sf.saxon.value

## Class DayTimeDurationValue

- java.lang.Object
- - net.sf.saxon.value.AtomicValue
  - - net.sf.saxon.value.DurationValue
    - - net.sf.saxon.value.DayTimeDurationValue

- All Implemented Interfaces:
    `java.lang.Comparable<DayTimeDurationValue>`, `java.lang.Iterable<AtomicValue>`, `AtomicMatchKey`, `AtomicSequence`, `GroundedValue`, `IdentityComparable`, `Item`, `Sequence`, `ConversionResult`

      public final class DayTimeDurationValue
      extends DurationValue
      implements java.lang.Comparable<DayTimeDurationValue>

  A value of type xs:dayTimeDuration.

  Internally this is held as an integer number of seconds held in a positive long, a positive integer number of microseconds in the range 0 to 999,999,999, and a boolean sign. Some of the constructor and accessor methods cannot handle the full range of values.

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.value.DurationValue

      `months, nanoseconds, negative, seconds`

    - ### Fields inherited from class net.sf.saxon.value.AtomicValue

      `typeLabel`

    - ### Fields inherited from interface net.sf.saxon.expr.sort.AtomicMatchKey

      `NaN_MATCH_KEY`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DayTimeDurationValue​(int sign, int days, int hours, int minutes, long seconds, int microseconds)` | Create a dayTimeDuration given the number of days, hours, minutes, and seconds.
    `DayTimeDurationValue​(int days, int hours, int minutes, long seconds, int nanoseconds)` | Create a dayTimeDuration given the number of days, hours, minutes, seconds, and nanoseconds.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `DurationValue` | `add​(DurationValue other)` | Add two dayTimeDurations
    `int` | `compareTo​(DayTimeDurationValue other)` | Compare the value to another duration value
    `AtomicValue` | `copyAsSubType​(AtomicType typeLabel)` | Create a copy of this atomic value, with a different type label
    `DurationValue` | `divide​(double n)` | Divide duration by a number.
    `BigDecimalValue` | `divide​(DurationValue other)` | Find the ratio between two durations
    `static DayTimeDurationValue` | `fromJavaDuration​(java.time.Duration duration)` | Factory method taking a Java 8 `Duration` object
    `static DayTimeDurationValue` | `fromMicroseconds​(long microseconds)` | Construct a duration value as a number of microseconds.
    `static DayTimeDurationValue` | `fromMilliseconds​(long milliseconds)` | Construct a duration value as a number of milliseconds.
    `static DayTimeDurationValue` | `fromNanoseconds​(long nanoseconds)` | Construct a duration value as a number of nanoseconds.
    `static DayTimeDurationValue` | `fromSeconds​(java.math.BigDecimal seconds)` | Construct a duration value as a number of seconds.
    `long` | `getLengthInMicroseconds()` | Get the length of duration in microseconds, as a long
    `long` | `getLengthInNanoseconds()` | Get the length of duration in microseconds, as a long
    `double` | `getLengthInSeconds()` | Get the length of duration in seconds.
    `java.lang.CharSequence` | `getPrimitiveStringValue()` | Convert to string
    `BuiltInAtomicType` | `getPrimitiveType()` | Determine the primitive type of the value.
    `AtomicMatchKey` | `getXPathComparable​(boolean ordered, StringCollator collator, int implicitTimezone)` | Get a Comparable value that implements the XPath ordering comparison semantics for this value.
    `static ConversionResult` | `makeDayTimeDurationValue​(java.lang.CharSequence s)` | Factory method: create a duration value from a supplied string, in ISO 8601 format `[-]PnDTnHnMnS`
    `DayTimeDurationValue` | `multiply​(double n)` | Multiply duration by a number.
    `DurationValue` | `multiply​(long factor)` | Multiply a duration by an integer
    `DurationValue` | `negate()` | Negate a duration (same as subtracting from zero, but it preserves the type of the original duration)
    `DurationValue` | `subtract​(DurationValue other)` | Subtract two dayTime-durations
    `java.time.Duration` | `toJavaDuration()` | Convert this value to a Java 8 `Duration` object

    - ### Methods inherited from class net.sf.saxon.value.DurationValue

      `badDuration, badDuration, equals, formatFractionalSeconds, getComponent, getDays, getHours, getMicroseconds, getMinutes, getMonths, getNanoseconds, getSchemaComparable, getSchemaComparable, getSeconds, getTotalMonths, getTotalSeconds, getYears, hashCode, makeDuration, makeDuration, normalizeZeroDuration, signum, simpleInteger`

    - ### Methods inherited from class net.sf.saxon.value.AtomicValue

      `asAtomic, asMapKey, atomize, checkPermittedContents, checkValidInJavascript, effectiveBooleanValue, getCanonicalLexicalRepresentation, getCardinality, getGenre, getItemType, getLength, getStringValue, getStringValueCS, getUType, head, identityHashCode, isIdentical, isIdentical, isNaN, itemAt, iterate, iterator, setTypeLabel, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.expr.sort.AtomicMatchKey

      `asAtomic`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `isStreamed, reduce, subsequence, toShortString`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

- - ### Constructor Detail

    - #### DayTimeDurationValue

          public DayTimeDurationValue​(int sign,
                                      int days,
                                      int hours,
                                      int minutes,
                                      long seconds,
                                      int microseconds)
                               throws java.lang.IllegalArgumentException

      Create a dayTimeDuration given the number of days, hours, minutes, and seconds. This constructor performs limited validation. The components (apart from sign) must all be non-negative integers; they need not be normalized (for example, 36 hours is acceptable)

      Note: for historic reasons this constructor only supports microsecond precision. For nanosecond precision, use the constructor `DayTimeDurationValue(int, int, int, long, int)`

      Parameters:
        `sign` - positive number for positive durations, negative for negative duratoins
        `days` - number of days
        `hours` - number of hours
        `minutes` - number of minutes
        `seconds` - number of seconds
        `microseconds` - number of microseconds
      Throws:
        `java.lang.IllegalArgumentException` - if the value is out of range; specifically, if the total number of seconds exceeds 2^63; or if any of the values is negative

    - #### DayTimeDurationValue

          public DayTimeDurationValue​(int days,
                                      int hours,
                                      int minutes,
                                      long seconds,
                                      int nanoseconds)
                               throws java.lang.IllegalArgumentException

      Create a dayTimeDuration given the number of days, hours, minutes, seconds, and nanoseconds. This constructor performs limited validation. The components need not be normalized (for example, 36 hours is acceptable)

      To construct a positive duration, all the component values should be positive integers (or zero). To construct a negative duration, all the component values should be negative integers (or zero).

      Parameters:
        `days` - number of days
        `hours` - number of hours
        `minutes` - number of minutes
        `seconds` - number of seconds
        `nanoseconds` - number of nanoseconds
      Throws:
        `java.lang.IllegalArgumentException` - if the value is out of range; specifically, if the total number of seconds exceeds 2^63; or if some values are positive and others are negative

  - ### Method Detail

    - #### makeDayTimeDurationValue

          public static ConversionResult makeDayTimeDurationValue​(java.lang.CharSequence s)

      Factory method: create a duration value from a supplied string, in ISO 8601 format `[-]PnDTnHnMnS`
      Parameters:
        `s` - the lexical representation of the xs:dayTimeDuration value
      Returns:
        a `DayTimeDurationValue` if the format is correct, or a `ValidationFailure` if not

    - #### copyAsSubType

          public AtomicValue copyAsSubType​(AtomicType typeLabel)

      Create a copy of this atomic value, with a different type label
      Overrides:
        `copyAsSubType` in class `DurationValue`
      Parameters:
        `typeLabel` - the type label of the new copy. The caller is responsible for checking that the value actually conforms to this type.
      Returns:
        the copied value

    - #### getPrimitiveType

          public BuiltInAtomicType getPrimitiveType()

      Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.
      Overrides:
        `getPrimitiveType` in class `DurationValue`
      Returns:
        the primitive type

    - #### getPrimitiveStringValue

          public java.lang.CharSequence getPrimitiveStringValue()

      Convert to string
      Overrides:
        `getPrimitiveStringValue` in class `DurationValue`
      Returns:
        ISO 8601 representation.

    - #### getLengthInSeconds

          public double getLengthInSeconds()

      Get the length of duration in seconds. Note this may involve loss of precision. For an exact result, use `DurationValue.getTotalSeconds()`
      Overrides:
        `getLengthInSeconds` in class `DurationValue`
      Returns:
        an approximation to the length of the duration in seconds, expressed as a double.

    - #### getLengthInMicroseconds

          public long getLengthInMicroseconds()

      Get the length of duration in microseconds, as a long
      Returns:
        the length in nanoseconds, divided by one thousand, rounded towards zero
      Throws:
        `java.lang.ArithmeticException` - if the number of microseconds is too high to be returned as a long.

    - #### getLengthInNanoseconds

          public long getLengthInNanoseconds()

      Get the length of duration in microseconds, as a long
      Returns:
        the length in nanoseconds, divided by one thousand, rounded towards zero
      Throws:
        `java.lang.ArithmeticException` - if the number of nanoseconds is too high to be returned as a long.

    - #### fromSeconds

          public static DayTimeDurationValue fromSeconds​(java.math.BigDecimal seconds)

      Construct a duration value as a number of seconds.
      Parameters:
        `seconds` - the number of seconds in the duration. May be negative
      Returns:
        the xs:dayTimeDuration value with the specified length
      Throws:
        `java.lang.ArithmeticException` - if the number of (whole) seconds exceeds 2^63

    - #### fromMilliseconds

          public static DayTimeDurationValue fromMilliseconds​(long milliseconds)
                                                       throws ValidationException

      Construct a duration value as a number of milliseconds.
      Parameters:
        `milliseconds` - the number of milliseconds in the duration (may be negative)
      Returns:
        the corresponding xs:dayTimeDuration value
      Throws:
        `ValidationException` - if implementation-defined limits are exceeded, specifically if the total number of seconds exceeds 2^63.

    - #### fromMicroseconds

          public static DayTimeDurationValue fromMicroseconds​(long microseconds)
                                                       throws java.lang.IllegalArgumentException

      Construct a duration value as a number of microseconds.
      Parameters:
        `microseconds` - the number of microseconds in the duration.
      Returns:
        the xs:dayTimeDuration represented by the given number of microseconds
      Throws:
        `java.lang.IllegalArgumentException`

    - #### fromNanoseconds

          public static DayTimeDurationValue fromNanoseconds​(long nanoseconds)
                                                      throws java.lang.IllegalArgumentException

      Construct a duration value as a number of nanoseconds.
      Parameters:
        `nanoseconds` - the number of nanoseconds in the duration.
      Returns:
        the xs:dayTimeDuration represented by the given number of nanoseconds
      Throws:
        `java.lang.IllegalArgumentException`

    - #### fromJavaDuration

          public static DayTimeDurationValue fromJavaDuration​(java.time.Duration duration)

      Factory method taking a Java 8 `Duration` object
      Parameters:
        `duration` - a duration as a Java 8 `java.time.Duration`
      Since:
        9.9

    - #### toJavaDuration

          public java.time.Duration toJavaDuration()

      Convert this value to a Java 8 `Duration` object
      Returns:
        the duration expressed as a Java 8 `java.time.Duration`
      Since:
        9.9

    - #### multiply

          public DurationValue multiply​(long factor)
                                 throws XPathException

      Multiply a duration by an integer
      Overrides:
        `multiply` in class `DurationValue`
      Parameters:
        `factor` - the number to multiply by
      Returns:
        the result of the multiplication
      Throws:
        `XPathException`

    - #### multiply

          public DayTimeDurationValue multiply​(double n)
                                        throws XPathException

      Multiply duration by a number. Follows the semantics of op:multiply-dayTimeDuration.
      Overrides:
        `multiply` in class `DurationValue`
      Parameters:
        `n` - the number to multiply by.
      Returns:
        the result of the multiplication
      Throws:
        `XPathException` - if the operand is Infinite or NaN, or if the resulting duration exceeds Saxon limits (2^63 seconds)

    - #### divide

          public DurationValue divide​(double n)
                               throws XPathException

      Divide duration by a number. Follows the semantics of op:divide-dayTimeDuration.
      Overrides:
        `divide` in class `DurationValue`
      Parameters:
        `n` - the number to divide by.
      Returns:
        the result of the division
      Throws:
        `XPathException` - if the operand is zero or NaN, or if the resulting duration exceeds Saxon limits (2^63 seconds)

    - #### divide

          public BigDecimalValue divide​(DurationValue other)
                                 throws XPathException

      Find the ratio between two durations
      Overrides:
        `divide` in class `DurationValue`
      Parameters:
        `other` - the dividend
      Returns:
        the ratio, as a decimal
      Throws:
        `XPathException` - when dividing by zero, or when dividing two durations of different type

    - #### add

          public DurationValue add​(DurationValue other)
                            throws XPathException

      Add two dayTimeDurations
      Overrides:
        `add` in class `DurationValue`
      Parameters:
        `other` - the duration to be added to this one
      Returns:
        the sum of the two durations
      Throws:
        `XPathException`

    - #### subtract

          public DurationValue subtract​(DurationValue other)
                                 throws XPathException

      Subtract two dayTime-durations
      Overrides:
        `subtract` in class `DurationValue`
      Parameters:
        `other` - the duration to be subtracted from this one
      Returns:
        the difference of the two durations
      Throws:
        `XPathException`

    - #### negate

          public DurationValue negate()
                               throws java.lang.IllegalArgumentException

      Negate a duration (same as subtracting from zero, but it preserves the type of the original duration)
      Overrides:
        `negate` in class `DurationValue`
      Returns:
        the original duration with its sign reversed, retaining its type
      Throws:
        `java.lang.IllegalArgumentException` - in the extremely unlikely event that the duration is one that cannot be negated (because the limit for positive durations is one second off from the limit for negative durations)

    - #### compareTo

          public int compareTo​(DayTimeDurationValue other)

      Compare the value to another duration value
      Specified by:
        `compareTo` in interface `java.lang.Comparable<DayTimeDurationValue>`
      Parameters:
        `other` - The other dateTime value
      Returns:
        negative value if this one is the smaller, 0 if they are equal, positive value if this one is the greater.
      Throws:
        `java.lang.NullPointerException` - if the other value is null

    - #### getXPathComparable

          public AtomicMatchKey getXPathComparable​(boolean ordered,
                                                   StringCollator collator,
                                                   int implicitTimezone)

      Get a Comparable value that implements the XPath ordering comparison semantics for this value. Returns null if the value is not comparable according to XPath rules. The default implementation returns the value itself. This is modified for types such as xs:duration which allow ordering comparisons in XML Schema, but not in XPath.
      Overrides:
        `getXPathComparable` in class `DurationValue`
      Parameters:
        `ordered` - true if an ordered comparable is needed
        `collator` - Collation used for string comparison
        `implicitTimezone` - XPath dynamic context
      Returns:
        an Object whose equals() and hashCode() methods implement the XPath comparison semantics with respect to this atomic value. If ordered is specified, the result will either be null if no ordering is defined, or will be a Comparable